/*+
|                                               |
|     Trigger: DTULTATU_ESCOLARIDADE            |  
|     Tabela : ESCOLARIDADE                     |
|                                               |
|     Criao:                                  |
|     19/07/2007 - Luiz Passos                  |
|                                               |
+*/



CREATE OR REPLACE TRIGGER DTULTATU_ESCOLARIDADE
BEFORE INSERT OR UPDATE OR DELETE
ON ESCOLARIDADE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUESCOLAR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDESCOLARIDADE,0) <> NVL(:NEW.CDESCOLARIDADE,0)) OR
           (NVL(:OLD.DSESCOLARIDADE,0) <> NVL(:NEW.DSESCOLARIDADE,0)) THEN
         :NEW.DTULTATUESCOLAR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ESCOLARIDADE'  , '', 'CDESCOLARIDADE='||:OLD.CDESCOLARIDADE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ESCOLARIDADE MODIFY DTULTATUESCOLAR DEFAULT SYSDATE
/



-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ESCOLARIDADE','5.01.008'); END;
/

