/*
TECNISA - PRODUTO INTEGRAO

NOME: Importacao de Nota Fiscal Sesi - Gera_NF_Sesi

DESCRIO:
  JOB RESPONSAVEL PELA CHAMADA DA IMPORTAO DE NOTAS FISCAIS,
  ESPECIFICA DO CLIENTE SESI.

CRIAO:
12/05/2011 - JEFFERSON DE MELO GOUVEA

@C:\Win_511\Sql\End_Conv\SqlServer\Clientes\Ses\0003_SESSTRS_SES_JOB_IMPORTA_NF.SQL



   Para aplicar o job e executar a rotina de importao, deve ser substituido a palavra BASEDADOS pela base
que a procedure de importao est aplicada.
*/

USE msdb
GO

EXEC SP_DELETE_JOB @JOB_NAME = 'Importacao de Nota Fiscal Sesi'
GO

EXEC sp_add_job @job_name = 'Importacao de Nota Fiscal Sesi',
                @enabled = 1,
                @notify_level_eventlog = 2
GO

EXEC sp_add_jobstep 	@job_name = 'Importacao de Nota Fiscal Sesi',
							@step_name = 'Gera_NF_Sesi',
-- informar a base de dados na linha abaixo, exemplo: @database_name = 'sesi_511',
							@database_name = 'BASEDADOS',
							@command = 'exec SES_IMPORTA_NOTAFISCAL',
                     @step_id=1, 
							@cmdexec_success_code=0,
							@on_success_action=1,
							@on_success_step_id=0,
							@on_fail_action=2,
							@on_fail_step_id=0,
							@retry_attempts = 5,
							@retry_interval = 1
GO

EXEC sp_add_jobschedule @job_name= 'Importacao de Nota Fiscal Sesi',
								@name = 'ScheduleImportacao',
								@freq_type = 4,
								@freq_interval = 1,
								@freq_subday_interval = 10,
								@active_start_time = 0,
                        @enabled=1, 
								@freq_subday_type=4,
								@freq_relative_interval=0, 
								@freq_recurrence_factor=0, 
								@active_start_date=20110101,
								@active_end_date=99991231,
								@active_end_time=235959
GO

EXEC sp_add_jobserver 	@job_name = 'Importacao de Nota Fiscal Sesi',
								@server_name = @@servername
GO

EXEC sp_start_job @job_name = 'Importacao de Nota Fiscal Sesi'
GO

-- informar a base de dados na linha abaixo, exemplo: USE sesi_511
USE BASEDADOS
GO

-- VERSAO --
EXEC ATUVEROBJ 'Gera_NF_Sesi','5.11.000';
GO



